import { RspressPlugin } from '@rspress/shared';

interface CategoryMeta {
    label?: string;
    position?: number;
    sidebar_position?: number;
    collapsed?: boolean;
    collapsible?: boolean;
    link?: {
        type: string;
        id: string;
    };
}
interface FileMeta {
    title?: string;
    sidebar_label?: string;
    position?: number;
    sidebar_position?: number;
}
interface Category {
    meta?: CategoryMeta;
    path: string;
    length: number;
    children?: (Category | File)[];
}
interface File {
    meta: FileMeta;
    path: string;
    length: number;
    category?: Category;
    title: string;
}
declare function withBase(url: string, base: string): string;
interface Options {
    root: string;
    categories: string[];
    collapsed?: boolean;
}
declare function initFiles(paths: string[], userRoot: string): Promise<{
    meta: FileMeta;
    path: string;
    title: string;
    length: number;
}[]>;
declare function initAllCategories(paths: string[], userRoot: string, files: File[]): Promise<Category[]>;
declare function getRootCategories(rootCategories: string[], categories: Category[], files: File[]): Category[];
/**
 * The plugin is used to generate sidebar automatically.
 */
declare function pluginAutoSidebar(options: Options): RspressPlugin;

export { type Category, type CategoryMeta, type File, type FileMeta, type Options, getRootCategories, initAllCategories, initFiles, pluginAutoSidebar, withBase };
